import { IAM } from 'aws-sdk';
export declare type DocJson = string;
export interface MyPolicyStatement {
    Sid: string;
    Effect: string;
    Action: any;
    Resource: any;
}
export declare type MyPolicyDocument = {
    Version: string;
    Statement: MyPolicyStatement[];
};
export declare type LocalPolicyFile = {
    name: string;
    document: MyPolicyDocument;
};
export interface GetPolicyVersionResult {
    name: string;
    arn: string;
    document: string;
    versionId: string;
    isDefaultVersion?: boolean;
    createDate?: Date;
}
export declare function getPolicyDefaultVersion(policy: any): Promise<GetPolicyVersionResult>;
export declare type GetPolicyDefaultWithVersionInfoByArnResult = {
    defaultId: string;
    oldestId: string;
    count: number;
    currentPolicy: GetPolicyVersionResult;
};
export declare function getPolicyDefaultWithVersionInfoByArn(arn: string): Promise<GetPolicyDefaultWithVersionInfoByArnResult>;
export declare function listPolicyVersions(arn: string): Promise<IAM.PolicyVersion[]>;
export declare function createPolicy({ name, document }: LocalPolicyFile, indent: number): Promise<IAM.CreatePolicyResponse>;
export declare function createPolicyDefaultVersion(arn: string, doc: DocJson, indent: number): Promise<IAM.CreatePolicyVersionResponse>;
export declare function deletePolicyVersion(arn: string, versionId: string): Promise<{
    $response: import("aws-sdk").Response<{}, import("aws-sdk").AWSError>;
}>;
export declare function getPolicyArnPrefix(): Promise<string>;
export declare function readPolicyFile(filePath: string, varSet: any): Promise<LocalPolicyFile>;
export declare function convertDocToJSON(doc: object, indent?: number): DocJson;
