import { IAM } from 'aws-sdk';
export interface MyStatement {
    Effect: string;
    Principal: {
        Federated: string;
        Service: string;
    };
    Action: any;
    Condition: any;
}
export declare type MyRole = {
    RoleName: string;
    Path: string;
    AssumeRolePolicyDocument: {
        Version: string;
        Statement: MyStatement[];
    };
};
export declare type MyRoleDocument = {
    Role: MyRole;
    AttachedPolicies: IAM.AttachedPolicy[];
};
export declare type LocalRoleFile = {
    name: string;
    document: MyRoleDocument;
};
export declare function createRole(role: any): Promise<IAM.Role>;
export declare function getAttachedPoliciesByRole(roleName: string): Promise<IAM.AttachedPolicy[]>;
export declare function getRole(roleName: string): Promise<IAM.Role | null>;
export declare function getInstanceProfile(roleName: string): Promise<IAM.InstanceProfile | null>;
export declare function isEc2Role(role: MyRole): boolean;
export declare function readRoleFile(filePath: string, varSet: any): Promise<LocalRoleFile>;
