import { LocalRoleFile, MyRoleDocument, MyRole } from "../aws/role";
import { Result } from '../utils/result';
import { IAM } from "aws-sdk";
import { RolePolicyPair } from "../aws/attach";
export declare class RoleRegisterer {
    private _overwrite;
    constructor(opts?: any);
    register({ name, document }: LocalRoleFile): Promise<Result | Result[]>;
    _createRoleOrWithInstanceProfile(document: MyRoleDocument, results: Result[]): Promise<Result | MyRole | null>;
    _createRole(doc: MyRoleDocument, results: Result[]): Promise<MyRole | Result | null>;
    _createInstanceProfile(roleName: string, results: Result[]): Promise<IAM.InstanceProfile | null>;
    _addRoleToInstanceProfile(profileName: string, roleName: string, results: Result[]): Promise<void>;
    _getRolePolicies(role: MyRoleDocument): Promise<{
        attaching: RolePolicyPair[];
        detaching: RolePolicyPair[];
        unchanged: RolePolicyPair[];
    }>;
    _attachRolePolicy(params: RolePolicyPair): Promise<Result>;
    _detachRolePolicy(params: RolePolicyPair): Promise<Result>;
}
