import { MyRole, LocalRoleFile } from "../aws/role";
import { Result } from '../utils/result';
import { IAM } from "aws-sdk";
export declare class InvalidRoleError extends Error {
    target: any;
    diff: any;
    constructor(msg: string, target: string, diff?: any);
}
export declare class RoleValidator {
    private _color;
    private _invalidCnt;
    constructor(opts?: any);
    validate({ name, document }: LocalRoleFile): Promise<Result[] | null>;
    _validateRoleOrRoleWithInstanceProfile(definedRole: MyRole): Promise<void>;
    _validateAttachedPolicies(roleName: string, attachedPolicies: IAM.AttachedPolicy[]): Promise<Result[] | null>;
    isValid(): boolean;
    _convertForDiff(role: any): any;
}
